
#include <libmsql/msql.h>

extern "C" {

	int bmx_msqlFieldCount(m_result * result);
	char * bmx_msql_field_name(m_field * field);
	int bmx_msql_field_type(m_field * field);
	int bmx_msql_field_flags(m_field * field);
	int bmx_msql_field_length(m_field * field);
	int bmx_msql_getFieldWidth(int type);

}


int bmx_msqlFieldCount(m_result * result) {
	return result->numFields;
}

char * bmx_msql_field_name(m_field * field) {
	return field->name;
}

int bmx_msql_field_type(m_field * field) {
	return field->type;
}

int bmx_msql_field_flags(m_field * field) {
	return field->flags;
}

int bmx_msql_field_length(m_field * field) {
	return field->length;
}

int bmx_msql_getFieldWidth(int type) {
	
	switch(type)
	{
		case INT_TYPE:
		case INT8_TYPE:
		case INT16_TYPE:
		case UINT_TYPE:
		case UINT8_TYPE:
		case UINT16_TYPE:
		case MONEY_TYPE:
		case TIME_TYPE:
			return(8);

		case INT64_TYPE:
		case UINT64_TYPE:
			return(16);

		case DATE_TYPE:
			return(11);

		case DATETIME_TYPE:
			return(20);

		case MILLITIME_TYPE:
			return(13);

		case MILLIDATETIME_TYPE:
			return(24);

		case REAL_TYPE:
			return(12);

		case CIDR4_TYPE:
			return(21);
	}
	return(-1);
}

