SuperStrict

Framework BaH.DBmSQL
Import BRL.Random

Type TPersonStuff
	Field forename:String
	Field surname:String
	Field dataInt:Int
	Field dataFloat:Float
	Field dataDouble:Double
	Field dataLong:Long
End Type


Local db:TDBConnection = LoadDatabase("MSQL", "maxtest", "192.168.0.31", 0, "brucey", "brucey")

If Not db Then
	DebugLog("Didn't work...")
	End
End If

If db.hasError() Then
	errorAndClose(db)
End If

If db.isOpen() Then

	' Load up some data for insertion...

	Local names:String[][] = [ ..
		[ "Alfred", "Aho" ],   ..
		[ "Brian", "Kernighan" ], ..
		[ "Peter", "Weinberger" ] ]
		
	Local pstuff:TPersonStuff[] = New TPersonStuff[names.length]
	For Local i:Int = 0 Until names.length
		pstuff[i] = New TPersonStuff
		pstuff[i].forename = names[i][0]
		pstuff[i].surname = names[i][1]
		pstuff[i].dataInt = Rnd(1, 10)
		pstuff[i].dataFloat = Rnd(1, 10)
		pstuff[i].dataDouble = Rnd(1, 10)
		pstuff[i].dataLong = Rnd(1, 100000000000:Long)
	Next


	db.executeQuery("DROP SEQUENCE FROM person")
	db.executeQuery("DROP TABLE person")

	' Create a new table
	Local s:String = "CREATE TABLE person (id integer, " + ..
	  " forename text(30), surname text(30), dataint integer, datafloat real, datadouble real, datalong int64 )"

	db.executeQuery(s)

	If db.hasError() Then
		errorAndClose(db)
	End If

	db.executeQuery("CREATE INDEX person_idx ON person (id)")
	db.executeQuery("CREATE SEQUENCE ON person")


	' iterate round the array inserting new entries
	For Local i:Int = 0 Until names.length
		Local id:Int = 0
		Local query:TDatabaseQuery = db.executeQuery("SELECT _seq FROM person")
		If query.nextRow() Then
			id = query.rowRecord().getInt(0)
		End If

		db.executeQuery("INSERT INTO person values (" + id + ", '" + pstuff[i].forename + ..
			"', '" + pstuff[i].surname + "', " + pstuff[i].dataInt + ", " + pstuff[i].dataFloat + ..
			", " + pstuff[i].datadouble + ", " + pstuff[i].dataLong + ")")
		
		If db.hasError() Then
			errorAndClose(db)
		End If
	Next
	
	' select
	Local query:TDatabaseQuery = db.executeQuery("SELECT * FROM person")
	If db.hasError() Then
		errorAndClose(db)
	End If

	For Local record:TQueryRecord = EachIn query
		
		Local i:Int = record.value(0).getInt() - 1
		DebugLog(" IN  - " + pstuff[i].forename + " : " + pstuff[i].surname + " : " + pstuff[i].dataInt + ..
			" : " + pstuff[i].dataFloat + " : " + pstuff[i].dataDouble + " : " + pstuff[i].dataLong)
		
		DebugLog(" OUT - " + record.value(1).getString() + " : " + record.value(2).getString() + ..
			" : " + record.value(3).getInt() + " : " + record.value(4).getFloat() + ..
			" : " + record.value(5).getDouble() + " : " + record.value(6).getLong() )
	Next
			
	db.close()
	
End If

Function errorAndClose(db:TDBConnection)
	DebugLog(db.error().toString())
	db.close()
	End
End Function



